<?php
/**
 * @package revision-cleaner
 */
/*
Plugin Name: Revision Cleaner
Plugin URI: http://mengzhuo.org/lab/RevisionC/
Description: Auto clean your revisions
Version: 0.1
Author: Meng Zhuo
Author URI: http://mengzhuo.org
License: GPLv2 or later

*/

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

define('REVISIONCLEANER_VERSION', '0.1');
load_plugin_textdomain('revision-cleaner', false, dirname( plugin_basename( __FILE__ ) ) . '/po/');

// Make sure we don't expose any info if called directly [FROM AKISMET]
if ( !function_exists( 'add_action' ) ) {
	echo "Hi there!  I'm just a plugin, not much I can do when called directly.";
	exit;
}
if (!function_exists('Revis_Cleaner')):
    function Revis_Cleaner() {
        if (get_option('Revis_interval')){
        
            global $wpdb;
            $revis_ctop =  get_option('Revis_ctop');
            if ($revis_ctop){
                $current_user = wp_get_current_user();
                $ctop = ' AND `post_author`='.$current_user->data->ID.' ';
            }
                
            $current_gmt = time();
            $revis_interval = get_option('Revis_interval');
            $time_between = date("\"Y-m-d H:i:s\"",$current_gmt-$revis_interval);

            $clean_time = $wpdb->query("
            DELETE FROM $wpdb->posts
            WHERE `post_type` = 'revision'
            $ctop
            AND `post_date_gmt` < $time_between
            ");
            $Revis_Cleaned =  get_option('Revis_Cleaned');
            $Revis_Cleaned = $Revis_Cleaned+$clean_time;
            update_option('Revis_Cleaned',$Revis_Cleaned);
        }
        else{
            //init
            add_option('Revis_interval',86400,'','yes');
            add_option('Revis_Cleaned',0,'','yes');
            add_option('Revis_ctop',TRUE,'','yes');
        }
    }
    function Revis_Cleaner_callback(){
        $revis_interval = get_option('Revis_interval');
        $Revis_Cleaned = get_option('Revis_Cleaned');
        $revis_ctop = get_option('Revis_ctop');

        if (isset($_POST['submit']) != NULL){
            $message = __('Success!');
            if ($_POST['revis_interval'] != $revis_interval){
                 $revis_interval = $_POST['revis_interval'];
                    if(!update_option('Revis_interval',$revis_interval)){
                        $message = __('Save failed');
                    }
                }
            elseif($_POST['d'] || $_POST['h']){
                $revis_interval = (($_POST['d']?$_POST['d']:0)*86400)+(($_POST['h']?$_POST['h']:0)*3600);
                    if(!update_option('Revis_interval',$revis_interval)){
                        $message = __('Save failed');
                    }
            }
            if ($_POST['revis_ctop'] != $revis_ctop){
                 $revis_ctop = ($_POST['revis_ctop']=='on')?TRUE:FALSE;
                 update_option('Revis_ctop',$revis_ctop);
            }
            echo "<div class='updated'><strong><p>". $message . "</p></strong></div>";
        }
        //FIXME
        $revis_interval_rest = $revis_interval;
        if ($revis_interval_rest >= 86400){
           $d = floor($revis_interval_rest/86400);
           $revis_interval_rest -= $d*86400;
        }
        if ($revis_interval_rest >= 3600){
           $h = floor($revis_interval_rest/3600);
        }
        ?>
        <div class="wrap">
            <div id="icon-options-general" class="icon32"><br></div>
            <h2><?php _e('Revision Cleaner','revision-cleaner'); ?></h2>
            <form method='post' action=''>
                <table class="form-table">
                    <tbody>
                    <tr><th><?php _e('Simple Settings','revision-cleaner');?></th><td><p><?php _e('Revisions Last','revision-cleaner');?>
                    <input id='Revis_d' type='text' class="small-text" name='d' value="<?php echo $d;?>" /><?php _e('day','revision-cleaner')?>
                    <input id='Revis_h' type='text' class="small-text" name='h' value="<?php echo $h;?>"/><?php _e('hour','revision-cleaner')?></p></td></tr>
                    <tr valign="top">
                    <th scope="row"><?php _e('Advanced option','revision-cleaner');?></th>
                    <td><label for="revision_last_time">
                        <?php _e('Revisions Last','revision-cleaner');?><input name="revis_interval" type="text" id="revision_last_time" 
                    value="<?php echo $revis_interval; ?>" class="big-text"><?php _e('Seconds','revision-cleaner'); ?></label>
                    <br/>
                    <label for="ctop"><input type="checkbox" name="revis_ctop" id="ctop" <?php checked($revis_ctop, TRUE) ?> /><?php _e("Clean post author's revision only",'revision-cleaner');?></label></td></tr>
                    <tr valign="top"><th scope="row"><?php _e('Cleaned Revision','revision-cleaner');?></th><td><?php echo $Revis_Cleaned;?></td></tr>
                    </tbody>
                </table>
                <p class="submit"><input type="submit" name="submit" id="submit" class="button-primary" value="<?php _e('Save Changes'); ?>"></p>
            </form>
        </div>
    <?php
    }
    function Revis_Cleaner_menu(){
        add_options_page( __('Revision Cleaner','revision-cleaner'), __('Revision Cleaner','revision-cleaner'), 'manage_options', 'revision-cleaner-control-menu', 'Revis_Cleaner_callback');
    }
    add_action('admin_menu','Revis_Cleaner');
    add_action('admin_menu','Revis_Cleaner_menu');
else:
    wp_die(_e('Wow!Plugin:Revision Cleaner Conflicted with something'));
endif;

?>
